Index: src/backend/postmaster/postmaster.c
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/backend/postmaster/postmaster.c,v
retrieving revision 1.400
diff -c -w -r1.400 postmaster.c
*** src/backend/postmaster/postmaster.c	29 May 2004 22:48:19 -0000	1.400
--- src/backend/postmaster/postmaster.c	30 May 2004 02:12:40 -0000
***************
*** 276,281 ****
--- 276,283 ----
  static pid_t *win32_childPIDArray;
  static HANDLE *win32_childHNDArray;
  static unsigned long win32_numChildren = 0;
+ 
+ HANDLE PostmasterHandle;
  #endif
  
  static pid_t backend_forkexec(Port *port);
***************
*** 748,753 ****
--- 750,761 ----
  		ereport(FATAL,
  				(errcode(ERRCODE_OUT_OF_MEMORY),
  				 errmsg("out of memory")));
+ 
+ 	if (DuplicateHandle(GetCurrentProcess(), GetCurrentProcess(), GetCurrentProcess(),
+ 						&PostmasterHandle, 0, TRUE, DUPLICATE_SAME_ACCESS) == 0)
+ 		ereport(FATAL,
+ 				(errmsg("Unable to duplicate postmaster handle: %i", (int)GetLastError())));
+ 
  #endif
  
  	/*
***************
*** 3221,3226 ****
--- 3229,3237 ----
  
  	write_var(debug_flag, fp);
  	write_var(PostmasterPid, fp);
+ #ifdef WIN32
+ 	write_var(PostmasterHandle, fp);
+ #endif
  
  	StrNCpy(str_buf, my_exec_path, MAXPGPATH);
  	write_array_var(str_buf, fp);
***************
*** 3289,3294 ****
--- 3300,3308 ----
  
  	read_var(debug_flag, fp);
  	read_var(PostmasterPid, fp);
+ #ifdef WIN32
+ 	read_var(PostmasterHandle, fp);
+ #endif
  
  	read_array_var(str_buf, fp);
  	StrNCpy(my_exec_path, str_buf, MAXPGPATH);
Index: src/backend/storage/ipc/pmsignal.c
===================================================================
RCS file: /projects/cvsroot/pgsql-server/src/backend/storage/ipc/pmsignal.c,v
retrieving revision 1.14
diff -c -w -r1.14 pmsignal.c
*** src/backend/storage/ipc/pmsignal.c	29 May 2004 22:48:20 -0000	1.14
--- src/backend/storage/ipc/pmsignal.c	30 May 2004 02:12:41 -0000
***************
*** 21,26 ****
--- 21,29 ----
  #include "storage/pmsignal.h"
  #include "storage/shmem.h"
  
+ #ifdef WIN32
+ extern HANDLE PostmasterHandle;
+ #endif
  
  /*
   * The postmaster is signaled by its children by sending SIGUSR1.  The
***************
*** 115,123 ****
  		return (kill(PostmasterPid, 0) == 0);
  	}
  #else /* WIN32 */
! 	/*
! 	 * XXX needs to be implemented by somebody
! 	 */
! 	return true;
  #endif /* WIN32 */
  }
--- 118,123 ----
  		return (kill(PostmasterPid, 0) == 0);
  	}
  #else /* WIN32 */
! 	return (WaitForSingleObject(PostmasterHandle, 0) == WAIT_TIMEOUT);
  #endif /* WIN32 */
  }
